#include <time.h>
#include <stdio.h>

#include "mainwin.h"
#include "interface.h"
#include "support.h"
#include "connection.h"
#include "log.h"
#include "ruleset.h"
#include "format.h"

GtkWidget* get_main_window(void) {
    static GtkWidget *mw = NULL;

    if (!mw)
        mw = create_main_window();

    return mw;
}

void mainwin_init() {
    GtkWidget *mw;
    GdkColor color;
    
    mw = get_main_window();

    fill_icmp_menu(GTK_OPTION_MENU(lookup_widget(mw, "icmp_option_menu")), TRUE, default_icmp_code);
    
    log_widget_init();
    ruleset_widget_init();

    gdk_color_parse ("black", &color);
    gtk_widget_modify_bg(lookup_widget(mw, "title_eventbox"), GTK_STATE_NORMAL, &color);
    
    gtk_widget_show_all(mw);
    
}

void mainwin_update_status_bar() {
    GtkStatusbar *s;
    static guint ctx = (guint) -1;
    static gchar txt[256];

    s = GTK_STATUSBAR(lookup_widget(get_main_window(), "statusbar"));
    
    if (ctx == (guint) -1) 
        ctx = gtk_statusbar_get_context_id(s, "Recieved packets");
    else
        gtk_statusbar_pop(s, ctx);

    if (queued_conn_count || conn_current)
        snprintf(txt, sizeof(txt), "Recieved %u packets, %u oustanding", total_conn_count, queued_conn_count + (conn_current ? 1 : 0));
    else
        snprintf(txt, sizeof(txt), "Recieved %u packets", total_conn_count);
    
    gtk_statusbar_push(s, ctx, txt);
}
